<template>
  <div class="appBar">
    <v-app-bar
      :clipped-left="clipped"
      fixed
      app
      :color="currentRouteName === 'browse' ? bgColor : bgColor"
      flat
      class="hidden-md-and-down"
      :class="[{ 'pl-16 pr-16 pt-3 ': $vuetify.breakpoint.mdAndUp }]"
    >
      <!-- LOGO -->
      <div class="logo mt-2 mr-16">
        <v-img
          :src="logo"
          :title="title"
          max-height="20"
          max-width="100"
          @click="goHomePage"
        />
      </div>

      <!-- LEFT MENU -->
      <div v-show="!searchMode" :class="{ 'black-text': currentRouteName == 'product' }">
        <div class="left-menu-option d-flex">
          <v-menu offset-y>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                class="lowercase"
                :class="{
                  active:
                    activeTab === menus.BROWSESTREETWEAR.id ||
                    currentRouteName == menus.BROWSESTREETWEAR.name,
                }"
                text
                v-bind="attrs"
                v-on="on"
              >
                {{ $t('appBar.browseStreetWear') }}
                <v-icon
                  right
                  dark
                >
                  mdi-menu-down
                </v-icon>
              </v-btn>
            </template>
            <v-list>
              <v-list-item>
                <v-btn
                  block
                  dark
                  class="lowercase justify-start"
                  :class="{
                    active:
                      activeTab === menus.BROWSESTREETWEAR.id ||
                      currentRouteName == menus.BROWSESTREETWEAR.name,
                  }"
                  text
                  @click="goToPage(menus.BROWSESTREETWEAR.id)"
                >
                  {{ $t('appBar.rent') }}
                </v-btn>
              </v-list-item>
              <v-list-item>
                <v-btn
                  block
                  dark
                  class="lowercase justify-start"
                  :class="{
                    active:
                      activeTab === menus.SHOP.id ||
                      currentRouteName == menus.SHOP.name,
                  }"
                  text
                  @click="goToPage(menus.SHOP.id)"
                >
                  {{ $t('appBar.shop') }}
                </v-btn>
              </v-list-item>
            </v-list>
          </v-menu>
          <!-- <v-list class="py-0">
            <v-list-group>
              <template v-slot:activator>
                <v-list-item-content>
                  <v-list-item-title>
                    {{ $t('appBar.browseStreetWear') }}
                  </v-list-item-title>
                </v-list-item-content>
              </template>

              <v-list-item
                link
                @click="goToPage(menus.BROWSESTREETWEAR.id)"
              >
                <v-list-item-content>
                  <v-list-item-title>
                    {{ $t('appBar.browseStreetWear') }}
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              <v-list-item
                link
                @click="goToPage(menus.SHOP.id)"
              >
                <v-list-item-content>
                  <v-list-item-title>
                    {{ $t('appBar.shop') }}
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </v-list-group>
          </v-list> -->
          <!-- <v-btn
            class="lowercase"
            :class="{
              active:
                activeTab === menus.BROWSESTREETWEAR.id ||
                currentRouteName == menus.BROWSESTREETWEAR.name,
            }"
            text
            @click="goToPage(menus.BROWSESTREETWEAR.id)"
          >
            {{ $t('appBar.browseStreetWear') }}
          </v-btn> -->
          <v-btn
            class="lowercase "
            :class="{ active: activeTab === menus.HOWITWORKS.id }"
            text
            @click="goToPage(menus.HOWITWORKS.id)"
          >
            {{ $t('appBar.howItWorks') }}
          </v-btn>
          <v-btn
            class="lowercase "
            :class="{ active: activeTab === menus.PLANS.id }"
            text
            @click="goToPage(menus.PLANS.id)"
          >
            {{ $t('appBar.plans') }}
          </v-btn>
          <!-- <v-btn
            class="lowercase "
            :class="{
              active:
                activeTab === menus.SHOP.id ||
                currentRouteName == menus.SHOP.name,
            }"
            text
            @click="goToPage(menus.SHOP.id)"
          >
            {{ $t('appBar.shop') }}
          </v-btn> -->
          <v-btn
            class="lowercase "
            :class="{
              active:
                activeTab === menus.ABOUT.id ||
                currentRouteName == menus.ABOUT.name,
            }"
            text
            @click="goToPage(menus.ABOUT.id)"
          >
            {{ $t('appBar.about') }}
          </v-btn>
          <pick-for-me 
            v-if="currentRouteName != menus.BROWSESTREETWEAR.name"
            class=""
          />
        </div>
      </div>
      <v-spacer v-show="!searchMode" />

      <!-- RIGHT MENU -->
      <right-menu-option
        v-if="currentRouteName != menus.BROWSESTREETWEAR.name && currentRouteName != menus.SHOP.name"
        :route="currentRouteName"
        :current-account-route="currentAccountRoute"
        :route-query="currentRouteQuery"
        @show-search="showSearch"
      />
    </v-app-bar>

    <!-- Mobile -->
    <v-app-bar fixed app class="hidden-lg-and-up app-bar-nav-mobile" flat>
      <v-row
        id="app-bar-nav-mobile"
        class="d-flex justify-space-between align-center mt-1"
      >
        <!-- Logo -->
        <v-col
          id="logo-mobile"
          class="logo pa-0 pl-3"
          cols="5"
          @click="goHomePage"
        >
          <img id="logo-mobile" :src="logo" alt>
        </v-col>
        <v-col class="d-flex justify-end pt-3 pr-3" cols="6">
          <!-- WISHLIST -->
          <v-btn
            small
            icon
            class="ml-1 mr-1"
            @click="goToPage(menus.WISHLIST.id)"
          >
            <v-img
              :src="wishlistIcon"
              max-width="15"
              max-height="15"
            />
          </v-btn>

          <!-- ACCOUNT -->
          <v-btn
            small
            icon
            class="ml-1 mr-1"
            @click="goToPage(menus.ACCOUNT.id)"
          >
            <v-img
              :src="accountIcon"
              max-width="15"
              max-height="15"
            />
          </v-btn>

          <!-- BOX -->
          <v-badge
            v-if="
              cartItems.length > 0 && currentRouteName == menus.BROWSESTREETWEAR.name || 
              cartItems.length === 0 && currentRouteName == menus.BROWSESTREETWEAR.name
            "
            bordered
            color="badge"
            :content="cartItems.length > 0 ? cartItems.length : '0'"
            overlap
          >
            <v-btn
              small
              icon
              class="ml-1 mr-2"
              @click="goToPage(menus.CART.id)"
            >
              <v-img
                :src="boxIcon"
                max-width="15"
                max-height="15"
              />
            </v-btn>
          </v-badge>

          <!-- SHOPPING CART -->
          <v-badge
            v-if="
              cartShopItems.length > 0 && currentRouteName == menus.SHOP.name || 
              cartShopItems.length === 0 && currentRouteName == menus.SHOP.name
            "
            bordered
            color="badge"
            :content="
              cartShopItems.length > 0
                ? cartShopItems.length
                : '0'
            "
            overlap
          >
            <v-btn
              small
              icon
              @click="goToMobilePage(mobileMenus.SHOP.id)"
            >
              <v-img
                :src="cartIcon"
                max-width="15"
                max-height="15"
              />
            </v-btn>
          </v-badge>

          <!-- <v-btn
            v-else
            small
            icon
            class="ml-1 mr-2"
            @click="goToPage(menus.CART.id)"
          >
            <v-img
              :src="boxIcon"
              max-width="15"
              max-height="15"
            />
          </v-btn> -->

          <!-- Burger bar -->
          <v-btn small icon @click="openMenuDrawer">
            <v-icon>mdi-menu</v-icon>
          </v-btn>
        </v-col>
      </v-row>
    </v-app-bar>
  </div>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
const VueScrollTo = require('vue-scrollto')

@Component({
  computed: mapGetters({
    menus: 'menu/getMenu',
    mobileMenus: 'menu/getMobileMenu',
    cartItems: 'cart/getCartItems',
    cartShopItems: 'cart/getCartShopItems'
  })
})
export default class AppBar extends Vue {
    // Data
    menus!: any
    mobileMenus!: any
    activeTab: Number = 0
    searchMode: Boolean = false
    searchIcon: String = require('~/assets/images/search.png')
    clipped: Boolean = false
    bgColor: String = '#000000'
    title = this.$t('common.title')
    logo: String = require('~/assets/images/logo.svg')
    wishlistIcon: String = require('~/assets/images/wishlist.png')
    accountIcon: String = require('~/assets/images/account.png')
    box: String = require('~/assets/images/cartbox.png')
    boxIcon: String = require('~/assets/images/box.png')
    cartIcon: String = require('~/assets/images/cart.png')

    get currentRouteName () {
      return this.$route.name
    }

    get currentRouteQuery () {
      return this.$route.query.s
    }

    // Methods
    currentAccountRoute () {
      this.activeTab = 0
    }

    goHomePage () {
      this.activeTab = 0
      this.$router.push({ path: '/' })
    }

    changeBgColor () {
      if (window.scrollY > 100) {
        this.bgColor = '#000000'
      } else {
        this.bgColor = '#000000'
      }
    }

    goToMobilePage (id: Number) {
      switch (id) {
        case this.mobileMenus.SHOP.id:
          this.$router.push(this.mobileMenus.SHOP.path + '/checkout')
          break
      }
    }

    goToPage (id: Number) {
      switch (id) {
        case this.menus.BROWSESTREETWEAR.id:
          this.activeTab = this.menus.BROWSESTREETWEAR.id
          this.$router.push(this.menus.BROWSESTREETWEAR.path)
          break

        case this.menus.HOWITWORKS.id:
          this.activeTab = this.menus.HOWITWORKS.id
          VueScrollTo.scrollTo('.howitwork-section')
          this.$router.push(this.menus.HOME.path + '?scroll=howitworks')
          break

        case this.menus.PLANS.id:
          this.activeTab = this.menus.PLANS.id
          VueScrollTo.scrollTo('.plan-section')
          this.$router.push(this.menus.HOME.path + '?scroll=plans')
          break

        case this.menus.SHOP.id:
          this.activeTab = this.menus.SHOP.id
          this.$router.push(this.menus.SHOP.path)
          break

        case this.menus.ABOUT.id:
          this.activeTab = this.menus.ABOUT.id
          this.$router.push(this.menus.ABOUT.path)
          break

        case this.menus.ACCOUNT.id:
          this.$router.push(this.menus.ACCOUNT.path)
          break

        case this.menus.CART.id:
          this.$store.commit('drawerbar/setCartDrawer', true)
          break

        case this.menus.WISHLIST.id:
          this.$router.push(this.menus.WISHLIST.path)
          break

        default:
          this.$router.push('/')
          break
      }
    }

    showSearch (val:boolean) {
      this.searchMode = val
    }

    openMenuDrawer () {
      this.$store.commit('drawerbar/setMenuDrawer', true)
    }

    mounted () {
      /* window.onscroll = () => {
            window.addEventListener('scroll', this.changeBgColor)
        } */
    }
}
</script>
